/* ContentBox.c generated by valac 0.56.17, the Vala compiler
 * generated from ContentBox.vala, do not modify */

/*
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: 2020-2022 Louis Brauer <louis@brauer.family>
 */
/**
 * @file ContentBox.vala
 * @brief Defines the ContentBox widget for displaying content with a header and action button.
 *
 * This file contains the implementation of the ContentBox class, which is a custom
 * Gtk.Box widget used to display content with a header, optional icon, and an
 * optional action button. It provides a flexible layout for presenting various
 * types of content within the Tuner application.
 *
 * @namespace Tuner
 * @class ContentBox
 * @extends Gtk.Box
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <granite.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TUNER_TYPE_CONTENT_BOX (tuner_content_box_get_type ())
#define TUNER_CONTENT_BOX(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_CONTENT_BOX, TunerContentBox))
#define TUNER_CONTENT_BOX_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_CONTENT_BOX, TunerContentBoxClass))
#define TUNER_IS_CONTENT_BOX(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_CONTENT_BOX))
#define TUNER_IS_CONTENT_BOX_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_CONTENT_BOX))
#define TUNER_CONTENT_BOX_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_CONTENT_BOX, TunerContentBoxClass))

typedef struct _TunerContentBox TunerContentBox;
typedef struct _TunerContentBoxClass TunerContentBoxClass;
typedef struct _TunerContentBoxPrivate TunerContentBoxPrivate;

#define TUNER_TYPE_HEADER_LABEL (tuner_header_label_get_type ())
#define TUNER_HEADER_LABEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_HEADER_LABEL, TunerHeaderLabel))
#define TUNER_HEADER_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_HEADER_LABEL, TunerHeaderLabelClass))
#define TUNER_IS_HEADER_LABEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_HEADER_LABEL))
#define TUNER_IS_HEADER_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_HEADER_LABEL))
#define TUNER_HEADER_LABEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_HEADER_LABEL, TunerHeaderLabelClass))

typedef struct _TunerHeaderLabel TunerHeaderLabel;
typedef struct _TunerHeaderLabelClass TunerHeaderLabelClass;

#define TUNER_TYPE_ABSTRACT_CONTENT_LIST (tuner_abstract_content_list_get_type ())
#define TUNER_ABSTRACT_CONTENT_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_ABSTRACT_CONTENT_LIST, TunerAbstractContentList))
#define TUNER_ABSTRACT_CONTENT_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_ABSTRACT_CONTENT_LIST, TunerAbstractContentListClass))
#define TUNER_IS_ABSTRACT_CONTENT_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_ABSTRACT_CONTENT_LIST))
#define TUNER_IS_ABSTRACT_CONTENT_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_ABSTRACT_CONTENT_LIST))
#define TUNER_ABSTRACT_CONTENT_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_ABSTRACT_CONTENT_LIST, TunerAbstractContentListClass))

typedef struct _TunerAbstractContentList TunerAbstractContentList;
typedef struct _TunerAbstractContentListClass TunerAbstractContentListClass;
enum  {
	TUNER_CONTENT_BOX_0_PROPERTY,
	TUNER_CONTENT_BOX_CONTENT_PROPERTY,
	TUNER_CONTENT_BOX_NUM_PROPERTIES
};
static GParamSpec* tuner_content_box_properties[TUNER_CONTENT_BOX_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	TUNER_CONTENT_BOX_ACTION_ACTIVATED_SIG_SIGNAL,
	TUNER_CONTENT_BOX_CONTENT_CHANGED_SIG_SIGNAL,
	TUNER_CONTENT_BOX_NUM_SIGNALS
};
static guint tuner_content_box_signals[TUNER_CONTENT_BOX_NUM_SIGNALS] = {0};

struct _TunerContentBox {
	GtkBox parent_instance;
	TunerContentBoxPrivate * priv;
	TunerHeaderLabel* header_label;
};

struct _TunerContentBoxClass {
	GtkBoxClass parent_class;
};

struct _TunerContentBoxPrivate {
	GtkBox* _header;
	GtkBox* _content;
	TunerAbstractContentList* _content_list;
	GtkStack* _stack;
};

static gint TunerContentBox_private_offset;
static gpointer tuner_content_box_parent_class = NULL;

VALA_EXTERN GType tuner_content_box_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerContentBox, g_object_unref)
VALA_EXTERN GType tuner_header_label_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerHeaderLabel, g_object_unref)
VALA_EXTERN GType tuner_abstract_content_list_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerAbstractContentList, g_object_unref)
VALA_EXTERN TunerContentBox* tuner_content_box_new (GtkImage* icon,
                                        const gchar* title,
                                        const gchar* subtitle,
                                        const gchar* action_icon_name,
                                        const gchar* action_tooltip_text);
VALA_EXTERN TunerContentBox* tuner_content_box_construct (GType object_type,
                                              GtkImage* icon,
                                              const gchar* title,
                                              const gchar* subtitle,
                                              const gchar* action_icon_name,
                                              const gchar* action_tooltip_text);
VALA_EXTERN TunerHeaderLabel* tuner_header_label_new (const gchar* label,
                                          gint xpad,
                                          gint ypad);
VALA_EXTERN TunerHeaderLabel* tuner_header_label_construct (GType object_type,
                                                const gchar* label,
                                                gint xpad,
                                                gint ypad);
static void ___lambda21_ (TunerContentBox* self);
static void ____lambda21__gtk_button_clicked (GtkButton* _sender,
                                       gpointer self);
static void __lambda22_ (TunerContentBox* self);
static void ___lambda22__gtk_widget_show (GtkWidget* _sender,
                                   gpointer self);
VALA_EXTERN void tuner_content_box_show_alert (TunerContentBox* self);
VALA_EXTERN void tuner_content_box_show_nothing_found (TunerContentBox* self);
VALA_EXTERN TunerAbstractContentList* tuner_content_box_get_content (TunerContentBox* self);
VALA_EXTERN void tuner_content_box_set_content (TunerContentBox* self,
                                    TunerAbstractContentList* value);
static GObject * tuner_content_box_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties);
static void tuner_content_box_finalize (GObject * obj);
static GType tuner_content_box_get_type_once (void);
static void _vala_tuner_content_box_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_tuner_content_box_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);

static inline gpointer
tuner_content_box_get_instance_private (TunerContentBox* self)
{
	return G_STRUCT_MEMBER_P (self, TunerContentBox_private_offset);
}

/**
     * @brief Constructs a new ContentBox instance.
     *
     * @param icon The optional icon to display in the header.
     * @param title The title text for the header.
     * @param subtitle An optional subtitle to display below the header.
     * @param action_icon_name The name of the icon for the action button.
     * @param action_tooltip_text The tooltip text for the action button.
     */
static void
___lambda21_ (TunerContentBox* self)
{
	g_signal_emit (self, tuner_content_box_signals[TUNER_CONTENT_BOX_ACTION_ACTIVATED_SIG_SIGNAL], 0);
}

static void
____lambda21__gtk_button_clicked (GtkButton* _sender,
                                  gpointer self)
{
	___lambda21_ ((TunerContentBox*) self);
}

static void
__lambda22_ (TunerContentBox* self)
{
	GtkStack* _tmp0_;
	_tmp0_ = self->priv->_stack;
	gtk_stack_set_visible_child_full (_tmp0_, "content", GTK_STACK_TRANSITION_TYPE_NONE);
}

static void
___lambda22__gtk_widget_show (GtkWidget* _sender,
                              gpointer self)
{
	__lambda22_ ((TunerContentBox*) self);
}

TunerContentBox*
tuner_content_box_construct (GType object_type,
                             GtkImage* icon,
                             const gchar* title,
                             const gchar* subtitle,
                             const gchar* action_icon_name,
                             const gchar* action_tooltip_text)
{
	TunerContentBox * self = NULL;
	GtkStack* _tmp0_;
	GraniteWidgetsAlertView* alert = NULL;
	GraniteWidgetsAlertView* _tmp1_;
	GtkStack* _tmp2_;
	GraniteWidgetsAlertView* _tmp3_;
	GraniteWidgetsAlertView* no_results = NULL;
	GraniteWidgetsAlertView* _tmp4_;
	GtkStack* _tmp5_;
	GraniteWidgetsAlertView* _tmp6_;
	GtkBox* _tmp7_;
	GtkBox* _tmp8_;
	GtkBox* _tmp10_;
	TunerHeaderLabel* _tmp11_;
	TunerHeaderLabel* _tmp12_;
	gboolean _tmp13_ = FALSE;
	GtkBox* _tmp20_;
	GtkSeparator* _tmp23_;
	GtkSeparator* _tmp24_;
	GtkBox* _tmp25_;
	GtkBox* _tmp26_;
	GtkStyleContext* _tmp27_;
	GtkBox* _tmp28_;
	GtkBox* _tmp29_;
	GtkStyleContext* _tmp30_;
	GtkScrolledWindow* scroller = NULL;
	GtkScrolledWindow* _tmp31_;
	GtkBox* _tmp32_;
	GtkStack* _tmp33_;
	GtkStack* _tmp34_;
	g_return_val_if_fail (title != NULL, NULL);
	self = (TunerContentBox*) g_object_new (object_type, "orientation", GTK_ORIENTATION_VERTICAL, "spacing", 0, NULL);
	_tmp0_ = (GtkStack*) gtk_stack_new ();
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->_stack);
	self->priv->_stack = _tmp0_;
	_tmp1_ = granite_widgets_alert_view_new (_ ("Nothing here"), _ ("Something went wrong loading radio stations data from radio-browser.in" \
"fo. Please try again later."), "dialog-warning");
	g_object_ref_sink (_tmp1_);
	alert = _tmp1_;
	_tmp2_ = self->priv->_stack;
	_tmp3_ = alert;
	gtk_stack_add_named (_tmp2_, (GtkWidget*) _tmp3_, "alert");
	_tmp4_ = granite_widgets_alert_view_new (_ ("No stations found"), _ ("Please try a different search term."), "dialog-warning");
	g_object_ref_sink (_tmp4_);
	no_results = _tmp4_;
	_tmp5_ = self->priv->_stack;
	_tmp6_ = no_results;
	gtk_stack_add_named (_tmp5_, (GtkWidget*) _tmp6_, "nothing-found");
	_tmp7_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
	g_object_ref_sink (_tmp7_);
	_g_object_unref0 (self->priv->_header);
	self->priv->_header = _tmp7_;
	_tmp8_ = self->priv->_header;
	gtk_box_set_homogeneous (_tmp8_, FALSE);
	if (icon != NULL) {
		GtkBox* _tmp9_;
		_tmp9_ = self->priv->_header;
		gtk_box_pack_start (_tmp9_, (GtkWidget*) icon, FALSE, FALSE, (guint) 20);
	}
	_tmp10_ = self->priv->_header;
	_tmp11_ = tuner_header_label_new (title, 20, 20);
	g_object_ref_sink (_tmp11_);
	_tmp12_ = _tmp11_;
	gtk_box_pack_start (_tmp10_, (GtkWidget*) _tmp12_, FALSE, FALSE, (guint) 0);
	_g_object_unref0 (_tmp12_);
	if (action_icon_name != NULL) {
		_tmp13_ = action_tooltip_text != NULL;
	} else {
		_tmp13_ = FALSE;
	}
	if (_tmp13_) {
		GtkButton* shuffle_button = NULL;
		GtkButton* _tmp14_;
		GtkButton* _tmp15_;
		GtkButton* _tmp16_;
		GtkButton* _tmp17_;
		GtkBox* _tmp18_;
		GtkButton* _tmp19_;
		_tmp14_ = (GtkButton*) gtk_button_new_from_icon_name (action_icon_name, (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
		g_object_ref_sink (_tmp14_);
		shuffle_button = _tmp14_;
		_tmp15_ = shuffle_button;
		gtk_widget_set_valign ((GtkWidget*) _tmp15_, GTK_ALIGN_CENTER);
		_tmp16_ = shuffle_button;
		gtk_widget_set_tooltip_text ((GtkWidget*) _tmp16_, action_tooltip_text);
		_tmp17_ = shuffle_button;
		g_signal_connect_object (_tmp17_, "clicked", (GCallback) ____lambda21__gtk_button_clicked, self, 0);
		_tmp18_ = self->priv->_header;
		_tmp19_ = shuffle_button;
		gtk_box_pack_start (_tmp18_, (GtkWidget*) _tmp19_, FALSE, FALSE, (guint) 0);
		_g_object_unref0 (shuffle_button);
	}
	_tmp20_ = self->priv->_header;
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp20_, FALSE, FALSE, (guint) 0);
	if (subtitle != NULL) {
		GtkLabel* subtitle_label = NULL;
		GtkLabel* _tmp21_;
		GtkLabel* _tmp22_;
		_tmp21_ = (GtkLabel*) gtk_label_new (subtitle);
		g_object_ref_sink (_tmp21_);
		subtitle_label = _tmp21_;
		_tmp22_ = subtitle_label;
		gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp22_, TRUE, TRUE, (guint) 0);
		_g_object_unref0 (subtitle_label);
	}
	_tmp23_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
	g_object_ref_sink (_tmp23_);
	_tmp24_ = _tmp23_;
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp24_, FALSE, FALSE, (guint) 0);
	_g_object_unref0 (_tmp24_);
	_tmp25_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
	g_object_ref_sink (_tmp25_);
	_g_object_unref0 (self->priv->_content);
	self->priv->_content = _tmp25_;
	_tmp26_ = self->priv->_content;
	_tmp27_ = gtk_widget_get_style_context ((GtkWidget*) _tmp26_);
	gtk_style_context_add_class (_tmp27_, "color-light");
	_tmp28_ = self->priv->_content;
	gtk_widget_set_valign ((GtkWidget*) _tmp28_, GTK_ALIGN_START);
	_tmp29_ = self->priv->_content;
	_tmp30_ = gtk_widget_get_style_context ((GtkWidget*) _tmp29_);
	gtk_style_context_add_class (_tmp30_, "welcome");
	_tmp31_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
	g_object_ref_sink (_tmp31_);
	scroller = _tmp31_;
	g_object_set (scroller, "hscrollbar-policy", GTK_POLICY_NEVER, NULL);
	_tmp32_ = self->priv->_content;
	gtk_container_add ((GtkContainer*) scroller, (GtkWidget*) _tmp32_);
	gtk_scrolled_window_set_propagate_natural_height (scroller, TRUE);
	_tmp33_ = self->priv->_stack;
	gtk_stack_add_named (_tmp33_, (GtkWidget*) scroller, "content");
	_tmp34_ = self->priv->_stack;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp34_);
	g_signal_connect_object ((GtkWidget*) self, "show", (GCallback) ___lambda22__gtk_widget_show, self, 0);
	_g_object_unref0 (scroller);
	_g_object_unref0 (no_results);
	_g_object_unref0 (alert);
	return self;
}

TunerContentBox*
tuner_content_box_new (GtkImage* icon,
                       const gchar* title,
                       const gchar* subtitle,
                       const gchar* action_icon_name,
                       const gchar* action_tooltip_text)
{
	return tuner_content_box_construct (TUNER_TYPE_CONTENT_BOX, icon, title, subtitle, action_icon_name, action_tooltip_text);
}

/**
     * @brief Displays the alert view in the content area.
     */
void
tuner_content_box_show_alert (TunerContentBox* self)
{
	GtkStack* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_stack;
	gtk_stack_set_visible_child_full (_tmp0_, "alert", GTK_STACK_TRANSITION_TYPE_NONE);
}

/**
     * @brief Displays the "nothing found" view in the content area.
     */
void
tuner_content_box_show_nothing_found (TunerContentBox* self)
{
	GtkStack* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_stack;
	gtk_stack_set_visible_child_full (_tmp0_, "nothing-found", GTK_STACK_TRANSITION_TYPE_NONE);
}

TunerAbstractContentList*
tuner_content_box_get_content (TunerContentBox* self)
{
	TunerAbstractContentList* result;
	TunerAbstractContentList* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_content_list;
	result = _tmp0_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
tuner_content_box_set_content (TunerContentBox* self,
                               TunerAbstractContentList* value)
{
	GtkBox* _tmp0_;
	GList* _tmp1_;
	GtkStack* _tmp3_;
	TunerAbstractContentList* _tmp4_;
	GtkBox* _tmp5_;
	TunerAbstractContentList* _tmp6_;
	GtkBox* _tmp7_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_content;
	_tmp1_ = gtk_container_get_children ((GtkContainer*) _tmp0_);
	{
		GList* child_collection = NULL;
		GList* child_it = NULL;
		child_collection = _tmp1_;
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
			GtkWidget* child = NULL;
			child = (GtkWidget*) child_it->data;
			{
				GtkWidget* _tmp2_;
				_tmp2_ = child;
				gtk_widget_destroy (_tmp2_);
			}
		}
		(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
	}
	_tmp3_ = self->priv->_stack;
	gtk_stack_set_visible_child_full (_tmp3_, "content", GTK_STACK_TRANSITION_TYPE_NONE);
	_tmp4_ = _g_object_ref0 (value);
	_g_object_unref0 (self->priv->_content_list);
	self->priv->_content_list = _tmp4_;
	_tmp5_ = self->priv->_content;
	_tmp6_ = self->priv->_content_list;
	gtk_container_add ((GtkContainer*) _tmp5_, (GtkWidget*) _tmp6_);
	_tmp7_ = self->priv->_content;
	gtk_widget_show_all ((GtkWidget*) _tmp7_);
	g_signal_emit (self, tuner_content_box_signals[TUNER_CONTENT_BOX_CONTENT_CHANGED_SIG_SIGNAL], 0);
	g_object_notify_by_pspec ((GObject *) self, tuner_content_box_properties[TUNER_CONTENT_BOX_CONTENT_PROPERTY]);
}

static GObject *
tuner_content_box_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	TunerContentBox * self;
	GtkStyleContext* _tmp0_;
	parent_class = G_OBJECT_CLASS (tuner_content_box_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUNER_TYPE_CONTENT_BOX, TunerContentBox);
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_add_class (_tmp0_, "color-dark");
	return obj;
}

static void
tuner_content_box_class_init (TunerContentBoxClass * klass,
                              gpointer klass_data)
{
	tuner_content_box_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &TunerContentBox_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_tuner_content_box_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_tuner_content_box_set_property;
	G_OBJECT_CLASS (klass)->constructor = tuner_content_box_constructor;
	G_OBJECT_CLASS (klass)->finalize = tuner_content_box_finalize;
	/**
	     * @property content
	     * @brief Gets or sets the content list displayed in the ContentBox.
	     *
	     * When setting this property, it replaces the current content with the new
	     * AbstractContentList and emits the content_changed_sig signal.
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_CONTENT_BOX_CONTENT_PROPERTY, tuner_content_box_properties[TUNER_CONTENT_BOX_CONTENT_PROPERTY] = g_param_spec_object ("content", "content", "content", TUNER_TYPE_ABSTRACT_CONTENT_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	     * @signal action_activated_sig
	     * @brief Emitted when the action button is clicked.
	     */
	tuner_content_box_signals[TUNER_CONTENT_BOX_ACTION_ACTIVATED_SIG_SIGNAL] = g_signal_new ("action-activated-sig", TUNER_TYPE_CONTENT_BOX, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	/**
	     * @signal content_changed_sig
	     * @brief Emitted when the content of the ContentBox is changed.
	     */
	tuner_content_box_signals[TUNER_CONTENT_BOX_CONTENT_CHANGED_SIG_SIGNAL] = g_signal_new ("content-changed-sig", TUNER_TYPE_CONTENT_BOX, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
tuner_content_box_instance_init (TunerContentBox * self,
                                 gpointer klass)
{
	self->priv = tuner_content_box_get_instance_private (self);
}

static void
tuner_content_box_finalize (GObject * obj)
{
	TunerContentBox * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUNER_TYPE_CONTENT_BOX, TunerContentBox);
	_g_object_unref0 (self->header_label);
	_g_object_unref0 (self->priv->_header);
	_g_object_unref0 (self->priv->_content);
	_g_object_unref0 (self->priv->_content_list);
	_g_object_unref0 (self->priv->_stack);
	G_OBJECT_CLASS (tuner_content_box_parent_class)->finalize (obj);
}

/**
 * @class ContentBox
 * @brief A custom Gtk.Box widget for displaying content with a header and action button.
 *
 * The ContentBox class is a versatile widget used to present various types of content
 * within the Tuner application. It features a header with an optional icon and action
 * button, and a content area that can display different views based on the current state.
 *
 * @extends Gtk.Box
 */
static GType
tuner_content_box_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TunerContentBoxClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tuner_content_box_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TunerContentBox), 0, (GInstanceInitFunc) tuner_content_box_instance_init, NULL };
	GType tuner_content_box_type_id;
	tuner_content_box_type_id = g_type_register_static (gtk_box_get_type (), "TunerContentBox", &g_define_type_info, 0);
	TunerContentBox_private_offset = g_type_add_instance_private (tuner_content_box_type_id, sizeof (TunerContentBoxPrivate));
	return tuner_content_box_type_id;
}

GType
tuner_content_box_get_type (void)
{
	static volatile gsize tuner_content_box_type_id__once = 0;
	if (g_once_init_enter (&tuner_content_box_type_id__once)) {
		GType tuner_content_box_type_id;
		tuner_content_box_type_id = tuner_content_box_get_type_once ();
		g_once_init_leave (&tuner_content_box_type_id__once, tuner_content_box_type_id);
	}
	return tuner_content_box_type_id__once;
}

static void
_vala_tuner_content_box_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	TunerContentBox * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUNER_TYPE_CONTENT_BOX, TunerContentBox);
	switch (property_id) {
		case TUNER_CONTENT_BOX_CONTENT_PROPERTY:
		g_value_set_object (value, tuner_content_box_get_content (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_tuner_content_box_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	TunerContentBox * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUNER_TYPE_CONTENT_BOX, TunerContentBox);
	switch (property_id) {
		case TUNER_CONTENT_BOX_CONTENT_PROPERTY:
		tuner_content_box_set_content (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

