/* HeaderBar.c generated by valac 0.56.17, the Vala compiler
 * generated from HeaderBar.vala, do not modify */

/*
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: 2020-2022 Louis Brauer <louis@brauer.family>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <granite.h>
#include <pango/pango.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>

#define TUNER_HEADER_BAR_DEFAULT_ICON_NAME "internet-radio-symbolic"
#define TUNER_HEADER_BAR_SEARCH_DELAY 400
#define TUNER_WINDOW_ACTION_PREFIX "win."
#define TUNER_WINDOW_ACTION_PAUSE "action_pause"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TUNER_TYPE_HEADER_BAR (tuner_header_bar_get_type ())
#define TUNER_HEADER_BAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_HEADER_BAR, TunerHeaderBar))
#define TUNER_HEADER_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_HEADER_BAR, TunerHeaderBarClass))
#define TUNER_IS_HEADER_BAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_HEADER_BAR))
#define TUNER_IS_HEADER_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_HEADER_BAR))
#define TUNER_HEADER_BAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_HEADER_BAR, TunerHeaderBarClass))

typedef struct _TunerHeaderBar TunerHeaderBar;
typedef struct _TunerHeaderBarClass TunerHeaderBarClass;
typedef struct _TunerHeaderBarPrivate TunerHeaderBarPrivate;

#define TUNER_MODEL_TYPE_STATION (tuner_model_station_get_type ())
#define TUNER_MODEL_STATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_MODEL_TYPE_STATION, TunerModelStation))
#define TUNER_MODEL_STATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_MODEL_TYPE_STATION, TunerModelStationClass))
#define TUNER_MODEL_IS_STATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_MODEL_TYPE_STATION))
#define TUNER_MODEL_IS_STATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_MODEL_TYPE_STATION))
#define TUNER_MODEL_STATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_MODEL_TYPE_STATION, TunerModelStationClass))

typedef struct _TunerModelStation TunerModelStation;
typedef struct _TunerModelStationClass TunerModelStationClass;

#define TUNER_TYPE_REVEAL_LABEL (tuner_reveal_label_get_type ())
#define TUNER_REVEAL_LABEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_REVEAL_LABEL, TunerRevealLabel))
#define TUNER_REVEAL_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_REVEAL_LABEL, TunerRevealLabelClass))
#define TUNER_IS_REVEAL_LABEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_REVEAL_LABEL))
#define TUNER_IS_REVEAL_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_REVEAL_LABEL))
#define TUNER_REVEAL_LABEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_REVEAL_LABEL, TunerRevealLabelClass))

typedef struct _TunerRevealLabel TunerRevealLabel;
typedef struct _TunerRevealLabelClass TunerRevealLabelClass;
enum  {
	TUNER_HEADER_BAR_0_PROPERTY,
	TUNER_HEADER_BAR_PLAY_BUTTON_PROPERTY,
	TUNER_HEADER_BAR_TITLE_PROPERTY,
	TUNER_HEADER_BAR_SUBTITLE_PROPERTY,
	TUNER_HEADER_BAR_FAVICON_PROPERTY,
	TUNER_HEADER_BAR_NUM_PROPERTIES
};
static GParamSpec* tuner_header_bar_properties[TUNER_HEADER_BAR_NUM_PROPERTIES];
typedef enum  {
	TUNER_HEADER_BAR_PLAY_STATE_PAUSE_ACTIVE,
	TUNER_HEADER_BAR_PLAY_STATE_PAUSE_INACTIVE,
	TUNER_HEADER_BAR_PLAY_STATE_PLAY_ACTIVE,
	TUNER_HEADER_BAR_PLAY_STATE_PLAY_INACTIVE
} TunerHeaderBarPlayState;

#define TUNER_HEADER_BAR_TYPE_PLAY_STATE (tuner_header_bar_play_state_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block7Data Block7Data;

#define TUNER_TYPE_PREFERENCES_POPOVER (tuner_preferences_popover_get_type ())
#define TUNER_PREFERENCES_POPOVER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_PREFERENCES_POPOVER, TunerPreferencesPopover))
#define TUNER_PREFERENCES_POPOVER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_PREFERENCES_POPOVER, TunerPreferencesPopoverClass))
#define TUNER_IS_PREFERENCES_POPOVER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_PREFERENCES_POPOVER))
#define TUNER_IS_PREFERENCES_POPOVER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_PREFERENCES_POPOVER))
#define TUNER_PREFERENCES_POPOVER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_PREFERENCES_POPOVER, TunerPreferencesPopoverClass))

typedef struct _TunerPreferencesPopover TunerPreferencesPopover;
typedef struct _TunerPreferencesPopoverClass TunerPreferencesPopoverClass;

#define TUNER_TYPE_APPLICATION (tuner_application_get_type ())
#define TUNER_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_APPLICATION, TunerApplication))
#define TUNER_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_APPLICATION, TunerApplicationClass))
#define TUNER_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_APPLICATION))
#define TUNER_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_APPLICATION))
#define TUNER_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_APPLICATION, TunerApplicationClass))

typedef struct _TunerApplication TunerApplication;
typedef struct _TunerApplicationClass TunerApplicationClass;
enum  {
	TUNER_HEADER_BAR_STAR_CLICKED_SIG_SIGNAL,
	TUNER_HEADER_BAR_SEARCHED_FOR_SIG_SIGNAL,
	TUNER_HEADER_BAR_SEARCH_FOCUSED_SIG_SIGNAL,
	TUNER_HEADER_BAR_NUM_SIGNALS
};
static guint tuner_header_bar_signals[TUNER_HEADER_BAR_NUM_SIGNALS] = {0};

struct _TunerHeaderBar {
	GtkHeaderBar parent_instance;
	TunerHeaderBarPrivate * priv;
	GtkVolumeButton* volume_button;
};

struct _TunerHeaderBarClass {
	GtkHeaderBarClass parent_class;
};

struct _TunerHeaderBarPrivate {
	GtkButton* _play_button;
	GtkButton* _star_button;
	gboolean _starred;
	TunerModelStation* _station;
	GtkLabel* _title_label;
	TunerRevealLabel* _subtitle_label;
	GtkImage* _favicon_image;
	guint _delayed_changed_id;
	gchar* _searchentry_text;
};

struct _Block7Data {
	int _ref_count_;
	TunerHeaderBar* self;
	GtkSearchEntry* searchentry;
};

static gint TunerHeaderBar_private_offset;
static gpointer tuner_header_bar_parent_class = NULL;

VALA_EXTERN GType tuner_header_bar_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerHeaderBar, g_object_unref)
VALA_EXTERN GType tuner_model_station_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerModelStation, g_object_unref)
VALA_EXTERN GType tuner_reveal_label_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerRevealLabel, g_object_unref)
VALA_EXTERN GType tuner_header_bar_play_state_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void tuner_header_bar_handle_station_change (TunerHeaderBar* self);
VALA_EXTERN gboolean tuner_model_station_get_starred (TunerModelStation* self);
static void tuner_header_bar_set_starred (TunerHeaderBar* self,
                                   gboolean value);
VALA_EXTERN void tuner_header_bar_update_from_station (TunerHeaderBar* self,
                                           TunerModelStation* station);
static void _tuner_header_bar_handle_station_change_g_object_notify (GObject* _sender,
                                                              GParamSpec* pspec,
                                                              gpointer self);
static void tuner_header_bar_load_favicon (TunerHeaderBar* self,
                                    TunerModelStation* station);
static void __lambda13_ (TunerHeaderBar* self,
                  GObject* sender,
                  GParamSpec* property);
static void ___lambda13__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
VALA_EXTERN const gchar* tuner_model_station_get_title (TunerModelStation* self);
VALA_EXTERN void tuner_header_bar_set_title (TunerHeaderBar* self,
                                 const gchar* value);
VALA_EXTERN void tuner_header_bar_set_subtitle (TunerHeaderBar* self,
                                    const gchar* value);
static void tuner_header_bar_reset_timeout (TunerHeaderBar* self);
static gboolean __lambda14_ (TunerHeaderBar* self);
static gboolean ___lambda14__gsource_func (gpointer self);
VALA_EXTERN void tuner_header_bar_set_playstate (TunerHeaderBar* self,
                                     TunerHeaderBarPlayState state);
VALA_EXTERN GtkButton* tuner_header_bar_get_play_button (TunerHeaderBar* self);
VALA_EXTERN GtkImage* tuner_header_bar_get_favicon (TunerHeaderBar* self);
VALA_EXTERN void tuner_favicon_load_async (TunerModelStation* station,
                               gboolean forceReload,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_);
VALA_EXTERN GdkPixbuf* tuner_favicon_load_finish (GAsyncResult* _res_);
static void __lambda11_ (TunerHeaderBar* self,
                  GObject* favicon,
                  GAsyncResult* res);
static void ___lambda11__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void __lambda12_ (TunerHeaderBar* self,
                  GObject* favicon,
                  GAsyncResult* res);
static void ___lambda12__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
VALA_EXTERN TunerHeaderBar* tuner_header_bar_new (void);
VALA_EXTERN TunerHeaderBar* tuner_header_bar_construct (GType object_type);
VALA_EXTERN void tuner_header_bar_set_play_button (TunerHeaderBar* self,
                                       GtkButton* value);
VALA_EXTERN const gchar* tuner_header_bar_get_title (TunerHeaderBar* self);
VALA_EXTERN const gchar* tuner_header_bar_get_subtitle (TunerHeaderBar* self);
VALA_EXTERN const gchar* tuner_reveal_label_get_label (TunerRevealLabel* self);
VALA_EXTERN void tuner_reveal_label_set_label (TunerRevealLabel* self,
                                   const gchar* value);
VALA_EXTERN void tuner_header_bar_set_favicon (TunerHeaderBar* self,
                                   GtkImage* value);
static gboolean tuner_header_bar_get_starred (TunerHeaderBar* self);
static GObject * tuner_header_bar_constructor (GType type,
                                        guint n_construct_properties,
                                        GObjectConstructParam * construct_properties);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
VALA_EXTERN TunerRevealLabel* tuner_reveal_label_new (void);
VALA_EXTERN TunerRevealLabel* tuner_reveal_label_construct (GType object_type);
VALA_EXTERN TunerPreferencesPopover* tuner_preferences_popover_new (void);
VALA_EXTERN TunerPreferencesPopover* tuner_preferences_popover_construct (GType object_type);
VALA_EXTERN GType tuner_preferences_popover_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerPreferencesPopover, g_object_unref)
static void _tuner_header_bar___lambda16_ (Block7Data* _data7_);
static void __tuner_header_bar___lambda16__gtk_editable_changed (GtkEditable* _sender,
                                                          gpointer self);
static gboolean _tuner_header_bar___lambda17_ (TunerHeaderBar* self,
                                        GdkEventFocus* e);
static gboolean __tuner_header_bar___lambda17__gtk_widget_focus_in_event (GtkWidget* _sender,
                                                                   GdkEventFocus* event,
                                                                   gpointer self);
static void _tuner_header_bar___lambda18_ (TunerHeaderBar* self);
static void __tuner_header_bar___lambda18__gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self);
VALA_EXTERN GType tuner_application_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerApplication, g_object_unref)
VALA_EXTERN TunerApplication* tuner_application_get_instance (void);
VALA_EXTERN GSettings* tuner_application_get_settings (TunerApplication* self);
static void _tuner_header_bar___lambda19_ (TunerHeaderBar* self,
                                    gdouble value);
static void __tuner_header_bar___lambda19__gtk_scale_button_value_changed (GtkScaleButton* _sender,
                                                                    gdouble value,
                                                                    gpointer self);
static void tuner_header_bar_finalize (GObject * obj);
static GType tuner_header_bar_get_type_once (void);
static void _vala_tuner_header_bar_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static void _vala_tuner_header_bar_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec);

static inline gpointer
tuner_header_bar_get_instance_private (TunerHeaderBar* self)
{
	return G_STRUCT_MEMBER_P (self, TunerHeaderBar_private_offset);
}

/**
     * @enum PlayState
     * @brief Enumeration of possible play states for the play button.
     */
static GType
tuner_header_bar_play_state_get_type_once (void)
{
	static const GEnumValue values[] = {{TUNER_HEADER_BAR_PLAY_STATE_PAUSE_ACTIVE, "TUNER_HEADER_BAR_PLAY_STATE_PAUSE_ACTIVE", "pause-active"}, {TUNER_HEADER_BAR_PLAY_STATE_PAUSE_INACTIVE, "TUNER_HEADER_BAR_PLAY_STATE_PAUSE_INACTIVE", "pause-inactive"}, {TUNER_HEADER_BAR_PLAY_STATE_PLAY_ACTIVE, "TUNER_HEADER_BAR_PLAY_STATE_PLAY_ACTIVE", "play-active"}, {TUNER_HEADER_BAR_PLAY_STATE_PLAY_INACTIVE, "TUNER_HEADER_BAR_PLAY_STATE_PLAY_INACTIVE", "play-inactive"}, {0, NULL, NULL}};
	GType tuner_header_bar_play_state_type_id;
	tuner_header_bar_play_state_type_id = g_enum_register_static ("TunerHeaderBarPlayState", values);
	return tuner_header_bar_play_state_type_id;
}

GType
tuner_header_bar_play_state_get_type (void)
{
	static volatile gsize tuner_header_bar_play_state_type_id__once = 0;
	if (g_once_init_enter (&tuner_header_bar_play_state_type_id__once)) {
		GType tuner_header_bar_play_state_type_id;
		tuner_header_bar_play_state_type_id = tuner_header_bar_play_state_get_type_once ();
		g_once_init_leave (&tuner_header_bar_play_state_type_id__once, tuner_header_bar_play_state_type_id);
	}
	return tuner_header_bar_play_state_type_id__once;
}

/**
     * @brief Handle changes in the current station.
     *
     * This method updates the starred state when the current station changes.
     */
void
tuner_header_bar_handle_station_change (TunerHeaderBar* self)
{
	TunerModelStation* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_station;
	_tmp1_ = tuner_model_station_get_starred (_tmp0_);
	_tmp2_ = _tmp1_;
	tuner_header_bar_set_starred (self, _tmp2_);
}

/**
     * @brief Update the header bar with information from a new station.
     *
     * @param station The new station to display information for.
     */
static void
_tuner_header_bar_handle_station_change_g_object_notify (GObject* _sender,
                                                         GParamSpec* pspec,
                                                         gpointer self)
{
	tuner_header_bar_handle_station_change ((TunerHeaderBar*) self);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
__lambda13_ (TunerHeaderBar* self,
             GObject* sender,
             GParamSpec* property)
{
	g_return_if_fail (sender != NULL);
	g_return_if_fail (property != NULL);
	tuner_header_bar_handle_station_change (self);
}

static void
___lambda13__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	__lambda13_ ((TunerHeaderBar*) self, _sender, pspec);
}

void
tuner_header_bar_update_from_station (TunerHeaderBar* self,
                                      TunerModelStation* station)
{
	TunerModelStation* _tmp0_;
	TunerModelStation* _tmp3_;
	TunerModelStation* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp8_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (station != NULL);
	_tmp0_ = self->priv->_station;
	if (_tmp0_ != NULL) {
		TunerModelStation* _tmp1_;
		guint _tmp2_;
		_tmp1_ = self->priv->_station;
		g_signal_parse_name ("notify", G_TYPE_OBJECT, &_tmp2_, NULL, FALSE);
		g_signal_handlers_disconnect_matched ((GObject*) _tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _tuner_header_bar_handle_station_change_g_object_notify, self);
	}
	tuner_header_bar_load_favicon (self, station);
	_tmp3_ = _g_object_ref0 (station);
	_g_object_unref0 (self->priv->_station);
	self->priv->_station = _tmp3_;
	_tmp4_ = self->priv->_station;
	g_signal_connect_object ((GObject*) _tmp4_, "notify", (GCallback) ___lambda13__g_object_notify, self, 0);
	_tmp5_ = tuner_model_station_get_title (station);
	_tmp6_ = _tmp5_;
	tuner_header_bar_set_title (self, _tmp6_);
	tuner_header_bar_set_subtitle (self, _ ("Playing"));
	_tmp7_ = tuner_model_station_get_starred (station);
	_tmp8_ = _tmp7_;
	tuner_header_bar_set_starred (self, _tmp8_);
}

/**
     * @brief Reset the search timeout.
     *
     * This method removes any existing timeout and sets a new one for delayed search.
     */
static gboolean
__lambda14_ (TunerHeaderBar* self)
{
	const gchar* _tmp0_;
	gboolean result;
	self->priv->_delayed_changed_id = (guint) 0;
	_tmp0_ = self->priv->_searchentry_text;
	g_signal_emit (self, tuner_header_bar_signals[TUNER_HEADER_BAR_SEARCHED_FOR_SIG_SIGNAL], 0, _tmp0_);
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
___lambda14__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda14_ ((TunerHeaderBar*) self);
	return result;
}

static void
tuner_header_bar_reset_timeout (TunerHeaderBar* self)
{
	g_return_if_fail (self != NULL);
	if (self->priv->_delayed_changed_id > ((guint) 0)) {
		g_source_remove (self->priv->_delayed_changed_id);
	}
	self->priv->_delayed_changed_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) TUNER_HEADER_BAR_SEARCH_DELAY, ___lambda14__gsource_func, g_object_ref (self), g_object_unref);
}

/**
     * @brief Set the play state of the header bar.
     *
     * This method updates the play button icon and sensitivity based on the new play state.
     *
     * @param state The new play state to set.
     */
void
tuner_header_bar_set_playstate (TunerHeaderBar* self,
                                TunerHeaderBarPlayState state)
{
	g_return_if_fail (self != NULL);
	switch (state) {
		case TUNER_HEADER_BAR_PLAY_STATE_PLAY_ACTIVE:
		{
			GtkButton* _tmp0_;
			GtkImage* _tmp1_;
			GtkImage* _tmp2_;
			GtkButton* _tmp3_;
			GtkButton* _tmp4_;
			_tmp0_ = self->priv->_play_button;
			_tmp1_ = (GtkImage*) gtk_image_new_from_icon_name ("media-playback-start-symbolic", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
			g_object_ref_sink (_tmp1_);
			_tmp2_ = _tmp1_;
			gtk_button_set_image (_tmp0_, (GtkWidget*) _tmp2_);
			_g_object_unref0 (_tmp2_);
			_tmp3_ = self->priv->_play_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp3_, TRUE);
			_tmp4_ = self->priv->_star_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp4_, TRUE);
			break;
		}
		case TUNER_HEADER_BAR_PLAY_STATE_PLAY_INACTIVE:
		{
			GtkButton* _tmp5_;
			GtkImage* _tmp6_;
			GtkImage* _tmp7_;
			GtkButton* _tmp8_;
			GtkButton* _tmp9_;
			_tmp5_ = self->priv->_play_button;
			_tmp6_ = (GtkImage*) gtk_image_new_from_icon_name ("media-playback-pause-symbolic", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
			g_object_ref_sink (_tmp6_);
			_tmp7_ = _tmp6_;
			gtk_button_set_image (_tmp5_, (GtkWidget*) _tmp7_);
			_g_object_unref0 (_tmp7_);
			_tmp8_ = self->priv->_play_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp8_, FALSE);
			_tmp9_ = self->priv->_star_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp9_, FALSE);
			break;
		}
		case TUNER_HEADER_BAR_PLAY_STATE_PAUSE_ACTIVE:
		{
			GtkButton* _tmp10_;
			GtkImage* _tmp11_;
			GtkImage* _tmp12_;
			GtkButton* _tmp13_;
			GtkButton* _tmp14_;
			_tmp10_ = self->priv->_play_button;
			_tmp11_ = (GtkImage*) gtk_image_new_from_icon_name ("media-playback-stop-symbolic", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
			g_object_ref_sink (_tmp11_);
			_tmp12_ = _tmp11_;
			gtk_button_set_image (_tmp10_, (GtkWidget*) _tmp12_);
			_g_object_unref0 (_tmp12_);
			_tmp13_ = self->priv->_play_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp13_, TRUE);
			_tmp14_ = self->priv->_star_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp14_, TRUE);
			break;
		}
		case TUNER_HEADER_BAR_PLAY_STATE_PAUSE_INACTIVE:
		{
			GtkButton* _tmp15_;
			GtkImage* _tmp16_;
			GtkImage* _tmp17_;
			GtkButton* _tmp18_;
			GtkButton* _tmp19_;
			_tmp15_ = self->priv->_play_button;
			_tmp16_ = (GtkImage*) gtk_image_new_from_icon_name ("media-playback-stop-symbolic", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
			g_object_ref_sink (_tmp16_);
			_tmp17_ = _tmp16_;
			gtk_button_set_image (_tmp15_, (GtkWidget*) _tmp17_);
			_g_object_unref0 (_tmp17_);
			_tmp18_ = self->priv->_play_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp18_, FALSE);
			_tmp19_ = self->priv->_star_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp19_, FALSE);
			break;
		}
		default:
		break;
	}
}

/**
     * @brief Load and display the favicon for a station.
     *
     * This method asynchronously loads the favicon anew for 
     * the given station and updates the favicon image.
     * If the favicon is not available from the site, 
     * it will load the cached favicon or use the default icon.
     *
     * @param station The station whose favicon should be loaded.
     */
static void
__lambda11_ (TunerHeaderBar* self,
             GObject* favicon,
             GAsyncResult* res)
{
	GdkPixbuf* pxbuf = NULL;
	GdkPixbuf* _tmp0_;
	GdkPixbuf* _tmp1_;
	g_return_if_fail (res != NULL);
	_tmp0_ = tuner_favicon_load_finish (res);
	pxbuf = _tmp0_;
	_tmp1_ = pxbuf;
	if (_tmp1_ != NULL) {
		GtkImage* _tmp2_;
		GtkImage* _tmp3_;
		GdkPixbuf* _tmp4_;
		GtkImage* _tmp5_;
		GtkImage* _tmp6_;
		_tmp2_ = tuner_header_bar_get_favicon (self);
		_tmp3_ = _tmp2_;
		_tmp4_ = pxbuf;
		gtk_image_set_from_pixbuf (_tmp3_, _tmp4_);
		_tmp5_ = tuner_header_bar_get_favicon (self);
		_tmp6_ = _tmp5_;
		gtk_widget_set_size_request ((GtkWidget*) _tmp6_, 48, 48);
		_g_object_unref0 (pxbuf);
		return;
	}
	_g_object_unref0 (pxbuf);
}

static void
___lambda11__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
	__lambda11_ ((TunerHeaderBar*) self, source_object, res);
	g_object_unref (self);
}

static void
__lambda12_ (TunerHeaderBar* self,
             GObject* favicon,
             GAsyncResult* res)
{
	GdkPixbuf* pxbuf = NULL;
	GdkPixbuf* _tmp0_;
	GdkPixbuf* _tmp1_;
	GtkImage* _tmp7_;
	GtkImage* _tmp8_;
	g_return_if_fail (res != NULL);
	_tmp0_ = tuner_favicon_load_finish (res);
	pxbuf = _tmp0_;
	_tmp1_ = pxbuf;
	if (_tmp1_ != NULL) {
		GtkImage* _tmp2_;
		GtkImage* _tmp3_;
		GdkPixbuf* _tmp4_;
		_tmp2_ = tuner_header_bar_get_favicon (self);
		_tmp3_ = _tmp2_;
		_tmp4_ = pxbuf;
		gtk_image_set_from_pixbuf (_tmp3_, _tmp4_);
	} else {
		GtkImage* _tmp5_;
		GtkImage* _tmp6_;
		_tmp5_ = tuner_header_bar_get_favicon (self);
		_tmp6_ = _tmp5_;
		gtk_image_set_from_icon_name (_tmp6_, TUNER_HEADER_BAR_DEFAULT_ICON_NAME, (GtkIconSize) GTK_ICON_SIZE_DIALOG);
	}
	_tmp7_ = tuner_header_bar_get_favicon (self);
	_tmp8_ = _tmp7_;
	gtk_widget_set_size_request ((GtkWidget*) _tmp8_, 48, 48);
	_g_object_unref0 (pxbuf);
}

static void
___lambda12__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
	__lambda12_ ((TunerHeaderBar*) self, source_object, res);
	g_object_unref (self);
}

static void
tuner_header_bar_load_favicon (TunerHeaderBar* self,
                               TunerModelStation* station)
{
	GtkImage* _tmp0_;
	GtkImage* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (station != NULL);
	_tmp0_ = tuner_header_bar_get_favicon (self);
	_tmp1_ = _tmp0_;
	gtk_image_clear (_tmp1_);
	tuner_favicon_load_async (station, TRUE, ___lambda11__gasync_ready_callback, g_object_ref (self));
	tuner_favicon_load_async (station, FALSE, ___lambda12__gasync_ready_callback, g_object_ref (self));
}

TunerHeaderBar*
tuner_header_bar_construct (GType object_type)
{
	TunerHeaderBar * self = NULL;
	self = (TunerHeaderBar*) g_object_new (object_type, NULL);
	return self;
}

TunerHeaderBar*
tuner_header_bar_new (void)
{
	return tuner_header_bar_construct (TUNER_TYPE_HEADER_BAR);
}

GtkButton*
tuner_header_bar_get_play_button (TunerHeaderBar* self)
{
	GtkButton* result;
	GtkButton* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_play_button;
	result = _tmp0_;
	return result;
}

void
tuner_header_bar_set_play_button (TunerHeaderBar* self,
                                  GtkButton* value)
{
	GtkButton* old_value;
	g_return_if_fail (self != NULL);
	old_value = tuner_header_bar_get_play_button (self);
	if (old_value != value) {
		GtkButton* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_play_button);
		self->priv->_play_button = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, tuner_header_bar_properties[TUNER_HEADER_BAR_PLAY_BUTTON_PROPERTY]);
	}
}

const gchar*
tuner_header_bar_get_title (TunerHeaderBar* self)
{
	const gchar* result;
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_title_label;
	_tmp1_ = gtk_label_get_label (_tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}

void
tuner_header_bar_set_title (TunerHeaderBar* self,
                            const gchar* value)
{
	GtkLabel* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_title_label;
	gtk_label_set_label (_tmp0_, value);
	g_object_notify_by_pspec ((GObject *) self, tuner_header_bar_properties[TUNER_HEADER_BAR_TITLE_PROPERTY]);
}

const gchar*
tuner_header_bar_get_subtitle (TunerHeaderBar* self)
{
	const gchar* result;
	TunerRevealLabel* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_subtitle_label;
	_tmp1_ = tuner_reveal_label_get_label (_tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}

void
tuner_header_bar_set_subtitle (TunerHeaderBar* self,
                               const gchar* value)
{
	TunerRevealLabel* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_subtitle_label;
	tuner_reveal_label_set_label (_tmp0_, value);
	g_object_notify_by_pspec ((GObject *) self, tuner_header_bar_properties[TUNER_HEADER_BAR_SUBTITLE_PROPERTY]);
}

GtkImage*
tuner_header_bar_get_favicon (TunerHeaderBar* self)
{
	GtkImage* result;
	GtkImage* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_favicon_image;
	result = _tmp0_;
	return result;
}

void
tuner_header_bar_set_favicon (TunerHeaderBar* self,
                              GtkImage* value)
{
	GtkImage* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _g_object_ref0 (value);
	_g_object_unref0 (self->priv->_favicon_image);
	self->priv->_favicon_image = _tmp0_;
	g_object_notify_by_pspec ((GObject *) self, tuner_header_bar_properties[TUNER_HEADER_BAR_FAVICON_PROPERTY]);
}

static gboolean
tuner_header_bar_get_starred (TunerHeaderBar* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_starred;
	return result;
}

static void
tuner_header_bar_set_starred (TunerHeaderBar* self,
                              gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_starred = value;
	if (!self->priv->_starred) {
		GtkButton* _tmp0_;
		GtkImage* _tmp1_;
		GtkImage* _tmp2_;
		_tmp0_ = self->priv->_star_button;
		_tmp1_ = (GtkImage*) gtk_image_new_from_icon_name ("non-starred", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
		g_object_ref_sink (_tmp1_);
		_tmp2_ = _tmp1_;
		gtk_button_set_image (_tmp0_, (GtkWidget*) _tmp2_);
		_g_object_unref0 (_tmp2_);
	} else {
		GtkButton* _tmp3_;
		GtkImage* _tmp4_;
		GtkImage* _tmp5_;
		_tmp3_ = self->priv->_star_button;
		_tmp4_ = (GtkImage*) gtk_image_new_from_icon_name ("starred", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
		g_object_ref_sink (_tmp4_);
		_tmp5_ = _tmp4_;
		gtk_button_set_image (_tmp3_, (GtkWidget*) _tmp5_);
		_g_object_unref0 (_tmp5_);
	}
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
	g_atomic_int_inc (&_data7_->_ref_count_);
	return _data7_;
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
		TunerHeaderBar* self;
		self = _data7_->self;
		_g_object_unref0 (_data7_->searchentry);
		_g_object_unref0 (self);
		g_slice_free (Block7Data, _data7_);
	}
}

static void
_tuner_header_bar___lambda16_ (Block7Data* _data7_)
{
	TunerHeaderBar* self;
	GtkSearchEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	self = _data7_->self;
	_tmp0_ = _data7_->searchentry;
	_tmp1_ = gtk_entry_get_text ((GtkEntry*) _tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_strdup (_tmp2_);
	_g_free0 (self->priv->_searchentry_text);
	self->priv->_searchentry_text = _tmp3_;
	tuner_header_bar_reset_timeout (self);
}

static void
__tuner_header_bar___lambda16__gtk_editable_changed (GtkEditable* _sender,
                                                     gpointer self)
{
	_tuner_header_bar___lambda16_ (self);
}

static gboolean
_tuner_header_bar___lambda17_ (TunerHeaderBar* self,
                               GdkEventFocus* e)
{
	gboolean result;
	g_return_val_if_fail (e != NULL, FALSE);
	g_signal_emit (self, tuner_header_bar_signals[TUNER_HEADER_BAR_SEARCH_FOCUSED_SIG_SIGNAL], 0);
	result = TRUE;
	return result;
}

static gboolean
__tuner_header_bar___lambda17__gtk_widget_focus_in_event (GtkWidget* _sender,
                                                          GdkEventFocus* event,
                                                          gpointer self)
{
	gboolean result;
	result = _tuner_header_bar___lambda17_ ((TunerHeaderBar*) self, event);
	return result;
}

static void
_tuner_header_bar___lambda18_ (TunerHeaderBar* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	_tmp0_ = tuner_header_bar_get_starred (self);
	_tmp1_ = _tmp0_;
	g_signal_emit (self, tuner_header_bar_signals[TUNER_HEADER_BAR_STAR_CLICKED_SIG_SIGNAL], 0, _tmp1_);
}

static void
__tuner_header_bar___lambda18__gtk_button_clicked (GtkButton* _sender,
                                                   gpointer self)
{
	_tuner_header_bar___lambda18_ ((TunerHeaderBar*) self);
}

static void
_tuner_header_bar___lambda19_ (TunerHeaderBar* self,
                               gdouble value)
{
	TunerApplication* _tmp0_;
	TunerApplication* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	_tmp0_ = tuner_application_get_instance ();
	_tmp1_ = _tmp0_;
	_tmp2_ = tuner_application_get_settings (_tmp1_);
	_tmp3_ = _tmp2_;
	g_settings_set_double (_tmp3_, "volume", value);
}

static void
__tuner_header_bar___lambda19__gtk_scale_button_value_changed (GtkScaleButton* _sender,
                                                               gdouble value,
                                                               gpointer self)
{
	_tuner_header_bar___lambda19_ ((TunerHeaderBar*) self, value);
}

static GObject *
tuner_header_bar_constructor (GType type,
                              guint n_construct_properties,
                              GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	TunerHeaderBar * self;
	Block7Data* _data7_;
	GtkGrid* station_info = NULL;
	GtkGrid* _tmp0_;
	GtkGrid* _tmp1_;
	GtkGrid* _tmp2_;
	GtkLabel* _tmp3_;
	GtkLabel* _tmp4_;
	GtkStyleContext* _tmp5_;
	GtkLabel* _tmp6_;
	TunerRevealLabel* _tmp7_;
	GtkImage* _tmp8_;
	GtkGrid* _tmp9_;
	GtkImage* _tmp10_;
	GtkGrid* _tmp11_;
	GtkLabel* _tmp12_;
	GtkGrid* _tmp13_;
	TunerRevealLabel* _tmp14_;
	GtkGrid* _tmp15_;
	GtkButton* _tmp16_;
	GtkButton* _tmp17_;
	GtkButton* _tmp18_;
	GtkButton* _tmp19_;
	GtkButton* _tmp20_;
	GtkMenuButton* prefs_button = NULL;
	GtkMenuButton* _tmp21_;
	GtkMenuButton* _tmp22_;
	GtkImage* _tmp23_;
	GtkImage* _tmp24_;
	GtkMenuButton* _tmp25_;
	GtkMenuButton* _tmp26_;
	GtkMenuButton* _tmp27_;
	GtkMenuButton* _tmp28_;
	TunerPreferencesPopover* _tmp29_;
	TunerPreferencesPopover* _tmp30_;
	GtkMenuButton* _tmp31_;
	GtkSearchEntry* _tmp32_;
	GtkSearchEntry* _tmp33_;
	GtkSearchEntry* _tmp34_;
	GtkSearchEntry* _tmp35_;
	GtkSearchEntry* _tmp36_;
	GtkSearchEntry* _tmp37_;
	GtkButton* _tmp38_;
	GtkButton* _tmp39_;
	GtkButton* _tmp40_;
	GtkButton* _tmp41_;
	GtkButton* _tmp42_;
	GtkButton* _tmp43_;
	GtkVolumeButton* _tmp44_;
	GtkVolumeButton* _tmp45_;
	TunerApplication* _tmp46_;
	TunerApplication* _tmp47_;
	GSettings* _tmp48_;
	GSettings* _tmp49_;
	GtkVolumeButton* _tmp50_;
	GtkVolumeButton* _tmp51_;
	parent_class = G_OBJECT_CLASS (tuner_header_bar_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUNER_TYPE_HEADER_BAR, TunerHeaderBar);
	_data7_ = g_slice_new0 (Block7Data);
	_data7_->_ref_count_ = 1;
	_data7_->self = g_object_ref (self);
	gtk_header_bar_set_show_close_button ((GtkHeaderBar*) self, TRUE);
	_tmp0_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp0_);
	station_info = _tmp0_;
	_tmp1_ = station_info;
	g_object_set ((GtkWidget*) _tmp1_, "width-request", 200, NULL);
	_tmp2_ = station_info;
	gtk_grid_set_column_spacing (_tmp2_, 10);
	_tmp3_ = (GtkLabel*) gtk_label_new (_ ("Choose a station"));
	g_object_ref_sink (_tmp3_);
	_g_object_unref0 (self->priv->_title_label);
	self->priv->_title_label = _tmp3_;
	_tmp4_ = self->priv->_title_label;
	_tmp5_ = gtk_widget_get_style_context ((GtkWidget*) _tmp4_);
	gtk_style_context_add_class (_tmp5_, GRANITE_STYLE_CLASS_H4_LABEL);
	_tmp6_ = self->priv->_title_label;
	gtk_label_set_ellipsize (_tmp6_, PANGO_ELLIPSIZE_MIDDLE);
	_tmp7_ = tuner_reveal_label_new ();
	g_object_ref_sink (_tmp7_);
	_g_object_unref0 (self->priv->_subtitle_label);
	self->priv->_subtitle_label = _tmp7_;
	_tmp8_ = (GtkImage*) gtk_image_new_from_icon_name (TUNER_HEADER_BAR_DEFAULT_ICON_NAME, (GtkIconSize) GTK_ICON_SIZE_DIALOG);
	g_object_ref_sink (_tmp8_);
	_g_object_unref0 (self->priv->_favicon_image);
	self->priv->_favicon_image = _tmp8_;
	_tmp9_ = station_info;
	_tmp10_ = self->priv->_favicon_image;
	gtk_grid_attach (_tmp9_, (GtkWidget*) _tmp10_, 0, 0, 1, 2);
	_tmp11_ = station_info;
	_tmp12_ = self->priv->_title_label;
	gtk_grid_attach (_tmp11_, (GtkWidget*) _tmp12_, 1, 0, 1, 1);
	_tmp13_ = station_info;
	_tmp14_ = self->priv->_subtitle_label;
	gtk_grid_attach (_tmp13_, (GtkWidget*) _tmp14_, 1, 1, 1, 1);
	_tmp15_ = station_info;
	gtk_header_bar_set_custom_title ((GtkHeaderBar*) self, (GtkWidget*) _tmp15_);
	_tmp16_ = (GtkButton*) gtk_button_new ();
	g_object_ref_sink (_tmp16_);
	_tmp17_ = _tmp16_;
	tuner_header_bar_set_play_button (self, _tmp17_);
	_g_object_unref0 (_tmp17_);
	_tmp18_ = self->priv->_play_button;
	gtk_widget_set_valign ((GtkWidget*) _tmp18_, GTK_ALIGN_CENTER);
	_tmp19_ = self->priv->_play_button;
	gtk_actionable_set_action_name ((GtkActionable*) _tmp19_, TUNER_WINDOW_ACTION_PREFIX TUNER_WINDOW_ACTION_PAUSE);
	_tmp20_ = self->priv->_play_button;
	gtk_header_bar_pack_start ((GtkHeaderBar*) self, (GtkWidget*) _tmp20_);
	_tmp21_ = (GtkMenuButton*) gtk_menu_button_new ();
	g_object_ref_sink (_tmp21_);
	prefs_button = _tmp21_;
	_tmp22_ = prefs_button;
	_tmp23_ = (GtkImage*) gtk_image_new_from_icon_name ("open-menu", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
	g_object_ref_sink (_tmp23_);
	_tmp24_ = _tmp23_;
	gtk_button_set_image ((GtkButton*) _tmp22_, (GtkWidget*) _tmp24_);
	_g_object_unref0 (_tmp24_);
	_tmp25_ = prefs_button;
	gtk_widget_set_valign ((GtkWidget*) _tmp25_, GTK_ALIGN_CENTER);
	_tmp26_ = prefs_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp26_, TRUE);
	_tmp27_ = prefs_button;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp27_, _ ("Preferences"));
	_tmp28_ = prefs_button;
	_tmp29_ = tuner_preferences_popover_new ();
	g_object_ref_sink (_tmp29_);
	_tmp30_ = _tmp29_;
	gtk_menu_button_set_popover (_tmp28_, (GtkPopover*) _tmp30_);
	_g_object_unref0 (_tmp30_);
	_tmp31_ = prefs_button;
	gtk_header_bar_pack_end ((GtkHeaderBar*) self, (GtkWidget*) _tmp31_);
	_tmp32_ = (GtkSearchEntry*) gtk_search_entry_new ();
	g_object_ref_sink (_tmp32_);
	_data7_->searchentry = _tmp32_;
	_tmp33_ = _data7_->searchentry;
	gtk_widget_set_valign ((GtkWidget*) _tmp33_, GTK_ALIGN_CENTER);
	_tmp34_ = _data7_->searchentry;
	gtk_entry_set_placeholder_text ((GtkEntry*) _tmp34_, _ ("Station name"));
	_tmp35_ = _data7_->searchentry;
	g_signal_connect_data ((GtkEditable*) _tmp35_, "changed", (GCallback) __tuner_header_bar___lambda16__gtk_editable_changed, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
	_tmp36_ = _data7_->searchentry;
	g_signal_connect_object ((GtkWidget*) _tmp36_, "focus-in-event", (GCallback) __tuner_header_bar___lambda17__gtk_widget_focus_in_event, self, 0);
	_tmp37_ = _data7_->searchentry;
	gtk_header_bar_pack_end ((GtkHeaderBar*) self, (GtkWidget*) _tmp37_);
	_tmp38_ = (GtkButton*) gtk_button_new_from_icon_name ("non-starred", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
	g_object_ref_sink (_tmp38_);
	_g_object_unref0 (self->priv->_star_button);
	self->priv->_star_button = _tmp38_;
	_tmp39_ = self->priv->_star_button;
	gtk_widget_set_valign ((GtkWidget*) _tmp39_, GTK_ALIGN_CENTER);
	_tmp40_ = self->priv->_star_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp40_, TRUE);
	_tmp41_ = self->priv->_star_button;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp41_, _ ("Star this station"));
	_tmp42_ = self->priv->_star_button;
	g_signal_connect_object (_tmp42_, "clicked", (GCallback) __tuner_header_bar___lambda18__gtk_button_clicked, self, 0);
	_tmp43_ = self->priv->_star_button;
	gtk_header_bar_pack_start ((GtkHeaderBar*) self, (GtkWidget*) _tmp43_);
	_tmp44_ = (GtkVolumeButton*) gtk_volume_button_new ();
	g_object_ref_sink (_tmp44_);
	_g_object_unref0 (self->volume_button);
	self->volume_button = _tmp44_;
	_tmp45_ = self->volume_button;
	_tmp46_ = tuner_application_get_instance ();
	_tmp47_ = _tmp46_;
	_tmp48_ = tuner_application_get_settings (_tmp47_);
	_tmp49_ = _tmp48_;
	gtk_scale_button_set_value ((GtkScaleButton*) _tmp45_, g_settings_get_double (_tmp49_, "volume"));
	_tmp50_ = self->volume_button;
	g_signal_connect_object ((GtkScaleButton*) _tmp50_, "value-changed", (GCallback) __tuner_header_bar___lambda19__gtk_scale_button_value_changed, self, 0);
	_tmp51_ = self->volume_button;
	gtk_header_bar_pack_start ((GtkHeaderBar*) self, (GtkWidget*) _tmp51_);
	tuner_header_bar_set_playstate (self, TUNER_HEADER_BAR_PLAY_STATE_PAUSE_INACTIVE);
	_g_object_unref0 (prefs_button);
	_g_object_unref0 (station_info);
	block7_data_unref (_data7_);
	_data7_ = NULL;
	return obj;
}

static void
tuner_header_bar_class_init (TunerHeaderBarClass * klass,
                             gpointer klass_data)
{
	tuner_header_bar_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &TunerHeaderBar_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_tuner_header_bar_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_tuner_header_bar_set_property;
	G_OBJECT_CLASS (klass)->constructor = tuner_header_bar_constructor;
	G_OBJECT_CLASS (klass)->finalize = tuner_header_bar_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_HEADER_BAR_PLAY_BUTTON_PROPERTY, tuner_header_bar_properties[TUNER_HEADER_BAR_PLAY_BUTTON_PROPERTY] = g_param_spec_object ("play-button", "play-button", "play-button", gtk_button_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_HEADER_BAR_TITLE_PROPERTY, tuner_header_bar_properties[TUNER_HEADER_BAR_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_HEADER_BAR_SUBTITLE_PROPERTY, tuner_header_bar_properties[TUNER_HEADER_BAR_SUBTITLE_PROPERTY] = g_param_spec_string ("subtitle", "subtitle", "subtitle", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_HEADER_BAR_FAVICON_PROPERTY, tuner_header_bar_properties[TUNER_HEADER_BAR_FAVICON_PROPERTY] = g_param_spec_object ("favicon", "favicon", "favicon", gtk_image_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	tuner_header_bar_signals[TUNER_HEADER_BAR_STAR_CLICKED_SIG_SIGNAL] = g_signal_new ("star-clicked-sig", TUNER_TYPE_HEADER_BAR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
	tuner_header_bar_signals[TUNER_HEADER_BAR_SEARCHED_FOR_SIG_SIGNAL] = g_signal_new ("searched-for-sig", TUNER_TYPE_HEADER_BAR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
	tuner_header_bar_signals[TUNER_HEADER_BAR_SEARCH_FOCUSED_SIG_SIGNAL] = g_signal_new ("search-focused-sig", TUNER_TYPE_HEADER_BAR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
tuner_header_bar_instance_init (TunerHeaderBar * self,
                                gpointer klass)
{
	gchar* _tmp0_;
	self->priv = tuner_header_bar_get_instance_private (self);
	self->priv->_starred = FALSE;
	_tmp0_ = g_strdup ("");
	self->priv->_searchentry_text = _tmp0_;
}

static void
tuner_header_bar_finalize (GObject * obj)
{
	TunerHeaderBar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUNER_TYPE_HEADER_BAR, TunerHeaderBar);
	_g_object_unref0 (self->priv->_play_button);
	_g_object_unref0 (self->volume_button);
	_g_object_unref0 (self->priv->_star_button);
	_g_object_unref0 (self->priv->_station);
	_g_object_unref0 (self->priv->_title_label);
	_g_object_unref0 (self->priv->_subtitle_label);
	_g_object_unref0 (self->priv->_favicon_image);
	_g_free0 (self->priv->_searchentry_text);
	G_OBJECT_CLASS (tuner_header_bar_parent_class)->finalize (obj);
}

/**
 * @class Tuner.HeaderBar
 * @brief Custom header bar for the Tuner application.
 *
 * This class extends Gtk.HeaderBar to create a specialized header bar
 * with play/pause controls, volume control, station information display,
 * search functionality, and preferences menu.
 *
 * @extends Gtk.HeaderBar
 */
static GType
tuner_header_bar_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TunerHeaderBarClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tuner_header_bar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TunerHeaderBar), 0, (GInstanceInitFunc) tuner_header_bar_instance_init, NULL };
	GType tuner_header_bar_type_id;
	tuner_header_bar_type_id = g_type_register_static (gtk_header_bar_get_type (), "TunerHeaderBar", &g_define_type_info, 0);
	TunerHeaderBar_private_offset = g_type_add_instance_private (tuner_header_bar_type_id, sizeof (TunerHeaderBarPrivate));
	return tuner_header_bar_type_id;
}

GType
tuner_header_bar_get_type (void)
{
	static volatile gsize tuner_header_bar_type_id__once = 0;
	if (g_once_init_enter (&tuner_header_bar_type_id__once)) {
		GType tuner_header_bar_type_id;
		tuner_header_bar_type_id = tuner_header_bar_get_type_once ();
		g_once_init_leave (&tuner_header_bar_type_id__once, tuner_header_bar_type_id);
	}
	return tuner_header_bar_type_id__once;
}

static void
_vala_tuner_header_bar_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	TunerHeaderBar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUNER_TYPE_HEADER_BAR, TunerHeaderBar);
	switch (property_id) {
		case TUNER_HEADER_BAR_PLAY_BUTTON_PROPERTY:
		g_value_set_object (value, tuner_header_bar_get_play_button (self));
		break;
		case TUNER_HEADER_BAR_TITLE_PROPERTY:
		g_value_set_string (value, tuner_header_bar_get_title (self));
		break;
		case TUNER_HEADER_BAR_SUBTITLE_PROPERTY:
		g_value_set_string (value, tuner_header_bar_get_subtitle (self));
		break;
		case TUNER_HEADER_BAR_FAVICON_PROPERTY:
		g_value_set_object (value, tuner_header_bar_get_favicon (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_tuner_header_bar_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec)
{
	TunerHeaderBar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUNER_TYPE_HEADER_BAR, TunerHeaderBar);
	switch (property_id) {
		case TUNER_HEADER_BAR_PLAY_BUTTON_PROPERTY:
		tuner_header_bar_set_play_button (self, g_value_get_object (value));
		break;
		case TUNER_HEADER_BAR_TITLE_PROPERTY:
		tuner_header_bar_set_title (self, g_value_get_string (value));
		break;
		case TUNER_HEADER_BAR_SUBTITLE_PROPERTY:
		tuner_header_bar_set_subtitle (self, g_value_get_string (value));
		break;
		case TUNER_HEADER_BAR_FAVICON_PROPERTY:
		tuner_header_bar_set_favicon (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

